function [out]=para_test(r)
%Function to perform the parameter test

tic
if (isdeployed)
    %maxNumCompThreads(1)
    'test'
    if nargin==0
        r=input('which value should r have ?');
    else
    r=str2double(r);
    end
end 
simfunc = 'simfunc_skewt';    %Choosen Copula Modell
momfunc = 'momfunc_Equidep';     % moment functions to use in SMM estimation
T=500;                          % Sample Size
N=5;                            %Crosssectional dimension
theta01 = 1.0;                  %Parametervalue before and after the break at T/2
theta02 = 1.0;
iniSeed1=333*r;                   % fixing the RNG seed so that this code always gives the same result                
e0 = [T,N,iniSeed1,T];
B=1000;                           %Number of Bootstrap replications   
e1=[25*T,N,2*iniSeed1];

[~,data_raw]=datagen(T,N,r,theta01,theta02);
data=tiedrank(data_raw)/(T+1); 
theta_T=theta_t(data,e0);         %Full sample parameter estimate
G=G0(theta_T,data,simfunc,e1,momfunc); %Derivative Matrix
H=(G'*G)'\G';
K=Bootstrap(data_raw);
m0=feval(momfunc,data);
X=zeros(B,1);
%%%%%Determine Critical Value
parfor b=0:1:B-1
    m=0;
    dataB_T=tiedrank(K((1+T*b):(T+T*b),:))/(T+1);
    mB_T=feval(momfunc,dataB_T(1:T,:));
    A1=H*sqrt(T)*(mB_T-m0);  
    for t=0.2*T:T
      dataB_t=tiedrank(K((1+T*b):(t+T*b),:))/(t+1);
      mB_t=feval(momfunc,dataB_t);
      A=H*(t/T)*sqrt(T)*(mB_t-m0);
      A_star=(A-(t/T)*A1)'*(A-(t/T)*A1);
      if (A_star>m)
          m=A_star;
      end
    end
    X(b+1)=m;
end

q=quantile(X,0.95);
%%%%Determine Test Statistic
S_all=zeros(T,1);
parfor t=0.2*T:1:T
    raw_data_t=data_raw(1:t,:);
    data_t=tiedrank(raw_data_t)/(t+1);
    e0 = [t,N,iniSeed1,T];
    theta_ta=theta_t(data_t,e0);
    S=(t/T)*(1/sqrt(1/T))*(t/T)*(1/sqrt(1/T))*(theta_ta-theta_T)'*(theta_ta-theta_T);
    S_all(t,1)=S;   
end
maxS=max(S_all);
x=2;
if maxS>q
    x=1;
end

out=[maxS,q,x];
save(['output' num2str(r)],'out')

toc
end
