function [ theta_t ] = theta_t( data,e0 )
%Function estimates the parameter for a specific time point t
N = e0(2);          % the cross-section dimension (need N>=2)

S1 = 5 ;         % number of simulations in preliminary SMM, used just to get reasonable starting values (set to zero to skip this step)
S2 = 25 ;        % number of simulations in main SMM, used to get the actual estimate

     

iniSeed = e0(3);  % fixing the RNG seed so that this code always gives the same result

W = 1 ;                                
momfunc = 'momfunc_Equidep';        
simfunc = 'simfunc_skewt';
lh = -10; uh = 10;      % bound for parameter of Gaussian
theta_guess = 4;
T_all=e0(4);           
          

   % this case gets treated differently to the other two, as we do a grid search on nu to get better starting values
       if S1>=1
            ee1 = [T_all*S1, N, 2*iniSeed ];   % [ # of observations for simulated data, # of variables, seed]
            theta_ini = fminsearchbnd('objfunc_SMM',theta_guess,lh,uh,[],simfunc,ee1,momfunc,data,W);
        else
            theta_ini = theta_guess;
        end
        
        %%%%%% SMM estimation using (25 x T) simulated data %%%%%%%%%%%%%%%%%%%%%%%%%%%%
    ee2 = [T_all*S2, N, 2*iniSeed ];
    theta_t = fminsearchbnd('objfunc_SMM',theta_ini,lh,uh,[],simfunc,ee2,momfunc,data,W);
    
   
    

end

